//Below is the 78 chars line!
//----------------------------------------------------------------------------
//Jason Winnebeck

#include "chat.h"
#include "linklist.h"
#include <arpa/inet.h>  //for sockadd_in !!!
#include <curses.h>
#include <errno.h>

#include <string.h>

int gin  = 0;   //Total data received
int gout = 0;   //Total data sent

LinkList<Clidata> Clients;

int server;          //Socket to server
sockaddr_in servaddr;//Server's address

char buf[512];

CWindow  Stats;
CWindow  Room;
CWindow  Clilist;
CTextBox Message;

int Init() {
  errno = 0;            //Init vars
  gin = gout = 0;       //No data sent so far
  buf[511] = '\0';      //Make sure we will never overrun buffer

  //Create the Windows
  Stats.Move(1, 1, 80, 3);
  Stats.SetName("Connection Statistics");
  Stats.SetColors(0, 7, 8);
  Stats.Draw();
  Stats.Clear();
  Room.Move(17, 4, 64, 20);
  Room.SetName("Connecting. . .");
  Room.SetColors(0, 7, 8);
  Room.Draw();
  Room.Clear();
  Clilist.Move(1, 4, 16, 20);
  Clilist.SetName("Users");
  Clilist.SetColors(0, 7, 8);
  Clilist.Draw();
  Clilist.Clear();
  Message.Move(1, 23, 82, 4); //Slightly oversize to get rid of border
  Message.SetColors(0, 0, 15);
  Message.SetMax(159);
  Message.Reset();            //don't .draw()... ever! Only using inside.

  Clilist << "Joining. . .";
  Stats << "Connecting to server. . .";

  return 0;
}

void DisplayError() {
  endwin();
  cout << endl;
  cout << "This message is always displayed at exit and DOES NOT nessacarily mean an" << endl;
  cout << " error occured." << endl;
  cout << "errno: " << errno << " -- " << strerror(errno) << endl;
  cout << "Final Connection Statistics: " << endl;
  cout << "  Bytes sent    : " << gout << endl;
  cout << "  Bytes recieved: " << gin << endl;
}

void UpdateStats() {
  Stats.Clear();
  Stats << "Bytes Sent: " << gout << "  Bytes Recieved: " << gin << "  Number of Clients: " << Clients.Length();
}

void UpdateClilist() {
  Clilist.Clear();
  int l = Clients.Length();
  Clients.SetToStart();
  for (int c=0; c<l; c++) {
    Clilist << Clients._GetNext()->name << '\n';
    Clients._Advance();
  }
}
