//Below is the 78 chars line!
//----------------------------------------------------------------------------
//Jason Winnebeck

#include "server.h"
#include "window.h"
#include <errno.h>

#include <string.h>

int gin  = 0; //Total data received
int gout = 0; //Total data sent

int bsock = 0;//Broadcasting socket

LinkList<Clidata> Clients;

char buf[512];           //Global recieve buffer

CWindow Stats;
CWindow Message;
CWindow Clilist;

int Init() {
  errno = 0;            //Init vars
  gin = gout = 0;       //No data sent so far
  buf[511] = '\0';      //Make sure we will never overrun buffer

  //Create the Windows
  Stats.Move(1, 1, 80, 3);
  Stats.SetName("Connection Statistics");
  Stats.SetColors(0, 7, 8);
  Stats.Draw();
  Stats.Clear();
  Message.Move(1, 4, 40, 22);
  Message.SetName("Information");
  Message.SetColors(0, 7, 8);
  Message.Draw();
  Message.Clear();
  Clilist.Move(41, 4, 40, 22);
  Clilist.SetName("Client Info");
  Clilist.SetColors(0, 7, 8);
  Clilist.Draw();
  Clilist.Clear();

  Clilist << "No Clients yet...\n";

  return 0;
}

void DisplayError() {
  endwin();
  cout << endl;
  cout << "This message is always displayed at exit and DOES NOT nessacarily mean an" << endl;
  cout << " error occured." << endl;
  cout << "errno: " << errno << " -- " << strerror(errno) << endl;
  cout << "Final Connection Statistics: " << endl;
  cout << "  Bytes sent    : " << gout << endl;
  cout << "  Bytes recieved: " << gin << endl;
}

void UpdateStats() {
  Stats.Clear();
  Stats << "Bytes Sent: " << gout << "  Bytes Recieved: " << gin << "  Number of Clients: " << Clients.Length();
}

void UpdateClilist() {
  Clilist.Clear();
  int l = Clients.Length();
  Clients.SetToStart();
  for (int c=0; c<l; c++) {
    Clidata* cli = Clients._GetNext();  //Reduce clutter
    Clilist << cli->name << "  " << inet_ntoa(cli->loc.sin_addr) << "  " << cli->pingtime << "ms\n";
    Clients._Advance();
  }
}
