//Below is the 78 chars line!
//----------------------------------------------------------------------------
//Jason Winnebeck

#ifndef _TEXTBOX_H_
#define _TEXTBOX_H_

#include "window.h"

class CTextBox {
public:
  CTextBox();
  CTextBox(int x, int y, int w, int h);
  ~CTextBox();

  void  SetName(const char* str);                //Sets window title
  void  Move(int x, int y, int w, int h);        //Sets window position
  void  SetColors(int back, int fore, int text); //Sets window colors
  void  Draw();                                  //Draws window (OPTIONAL)
  void  Erase();                                 //Removes text box
  void  Reset();                                 //Clears and resets input
  void  SetMax(int max);                         //Max inputtable characters
                                                 //Also Reset()s

  bool  Update();       //Check for input, true if user finished input (ENTER)
  char* GetInput();     //returns NULL terminated input of exact size
                        //GetInput does NOT copy, so do not modify
private:
  CWindow box;  //Window for textbox
  char* input;  //string containing input
  int maxsize;  //max # of chars allowed to be inputted (don't include NULL)
  int currpos;  //Current position in string
};

#endif
